#include<iostream.h>
class TelephoneAccounts
{
	friend ostream &operator<<(ostream &, TelephoneAccounts &); 
public:
	TelephoneAccounts(unsigned int nbrmin=0, unsigned int vat=9)
	{
		nbrminutes=nbrmin;
		Vat=vat;
	}

	virtual void printbill(){}
protected:
	unsigned int nbrminutes;
	unsigned int Vat;
};
class LocalTelephoneAccounts :public TelephoneAccounts
{
		friend ostream &operator<<(ostream &, LocalTelephoneAccounts &);
public:
	LocalTelephoneAccounts( unsigned int monthlyfee=15000, unsigned int nbrofmin=0, unsigned int minprice=59,
		unsigned int cittax=2500,unsigned int vattax=9) :TelephoneAccounts(nbrofmin, vattax) 
	
	{
		MonthlySubscriptionFee=monthlyfee;
		MinutesPrice=minprice;
		CityTax=cittax;
	}
	void printbill()
	{
		cout<<"********Local Phone Account*********"<<endl;
		cout<<"City Tax= "<<CityTax<<" LBP"<<endl;
		cout<<"VAT Rate= "<<Vat<<" %"<<endl<<endl;
	}

protected:
	unsigned int MonthlySubscriptionFee;
	unsigned int MinutesPrice;
	unsigned int CityTax;

	};
class MobileTelephoneAccount :public TelephoneAccounts
{
	friend ostream &operator<<(ostream &, MobileTelephoneAccount &);
public:
	
		MobileTelephoneAccount( double monsubfee=29.0, unsigned int nbrosms=0,  double minfee=0.20,
		 double smsfee=0.25,unsigned int nbrofmin=0,unsigned int vattax=9) :TelephoneAccounts(nbrofmin, vattax)
			{
				monthlysubfee=monsubfee;
				nbrsms=nbrosms;
				smsprice=smsfee;
				minutesprice=minfee;
			}


void printbill()
{
		double month=(((monthlysubfee+(nbrsms*smsprice)+(nbrminutes*minutesprice))*Vat)/100);
		double total=(monthlysubfee+(nbrsms*smsprice)+(nbrminutes*minutesprice)+month);

		cout<<"*********Mobile Phone Bill**********"<<endl;
		cout<<"Monthly Fee= "<<monthlysubfee<<"$"<<endl;
		cout<<"Minutes Fee= "<<nbrminutes*minutesprice<<"$"<<endl;
		cout<<"SMS Fee= "<<nbrsms*smsprice<<"$"<<endl;
		cout<<"5 % of VAT= "<<month<<endl;
		cout<<"Total of: "<<total<<"$"<<endl<<endl;
	}
protected:
	 double monthlysubfee;
	 double nbrsms;
	 double smsprice;
	 double minutesprice;
};
class InternationalTelephoneAccount :public TelephoneAccounts
{
	friend ostream &operator<<(ostream &, InternationalTelephoneAccount &);
public:
	InternationalTelephoneAccount(unsigned int callprice=2000, unsigned int nbrocall=0,
	unsigned int minprice=700,unsigned int nbrofmin=0,unsigned int vattax=9) :TelephoneAccounts(nbrofmin, vattax)
	{
			callfee=callprice;
			numberofcalls=nbrocall;
			minuteprice=minprice;
	}

	void printbill()
	{ 
		double month=((((callfee*numberofcalls)+(nbrminutes*minuteprice))*Vat)/100);
		double total=((callfee*numberofcalls)+(nbrminutes*minuteprice)+month);
		cout<<"*********International Phone Bill**********"<<endl;
		cout<<"Call Price= "<<callfee*numberofcalls<<" LL"<<endl;
		cout<<"Minutes Price= "<<nbrminutes*minuteprice<<" $"<<endl;
		cout<<"10 % of VAT= "<<month<<endl;
		cout<<"Number of Calls= "<<numberofcalls<<endl<<endl;
	}

protected:
	unsigned int callfee;
	unsigned int numberofcalls;
	unsigned int minuteprice;
};


ostream &operator<<(ostream &out, LocalTelephoneAccounts &account)
{
	out<<"********Local Phone Account*********"<<endl;
	out<<"City Tax= "<<account.CityTax<<" LBP"<<endl;
	out<<"VAT Rate= "<<account.Vat<<" %"<<endl<<endl;
	return out;
}
ostream &operator<<(ostream &out, MobileTelephoneAccount &account)
{
	out<<"********Mobile Phone Bill*********"<<endl;
	out<<"Monthly Subscription Fee= "<<account.monthlysubfee<<" $"<<endl;
	out<<"Number of Minutes= "<<account.nbrminutes<<endl;
	out<<"Minutes Price: "<<account.minutesprice<<" LBP"<<endl;
	out<<"Number of SMS= "<<account.nbrsms<<endl;
	out<<"SMS Price= "<<account.smsprice<<"$"<<endl;
	out<<"VAT Rate= "<<account.Vat<<"%"<<endl<<endl;
	return out;
}
ostream &operator<<(ostream &out, InternationalTelephoneAccount &account)
{
	out<<"*********International Phone Account**********"<<endl;
	out<<"Number of Calls= "<<account.numberofcalls<<" LBP"<<endl;
	out<<"Call Price= "<<account.callfee<<" LBP"<<endl;
	out<<"Number of Minutes= "<<account.nbrminutes<<endl;
	out<<"Minutes Price: "<<account.minuteprice<<" LBP"<<endl;
	out<<"VAT Rate= "<<account.Vat<<" %"<<endl<<endl;
	return out;
}

void main()
{
	
	LocalTelephoneAccounts phone(14000,1);
	MobileTelephoneAccount cellphone(50);
	InternationalTelephoneAccount telephone(4000,2);
	
	phone.printbill();
	cellphone.printbill();
	telephone.printbill();
}