#include<iostream.h>
class TelephoneAccounts
{
	friend ostream &operator<<(ostream &, TelephoneAccounts &); 
public:
	TelephoneAccounts(unsigned int nbrmin=0, unsigned int vat=10)
	{
		nbrminutes=nbrmin;
		Vat=vat;
	}
	TelephoneAccounts operator+=(int num)
	{
		nbrminutes+=num;
			return *this;
	}
		
	virtual void printtax(){}
	virtual void printbill(){}
protected:
	unsigned int nbrminutes;
	unsigned int Vat;
};
class LocalTelephoneAccounts :public TelephoneAccounts
{
		friend ostream &operator<<(ostream &, LocalTelephoneAccounts &);
public:
	LocalTelephoneAccounts( unsigned int monthlyfee=12000, unsigned int nbrofmin=0, unsigned int minprice=49,
		unsigned int cittax=1500,unsigned int vattax=10) :TelephoneAccounts(nbrofmin, vattax) 
	
	{
		MonthlySubscriptionFee=monthlyfee;
		MinutesPrice=minprice;
		CityTax=cittax;
	}
	void printtax()
	{
		cout<<"********Local Phone Account*********"<<endl;
		cout<<"City Tax= "<<CityTax<<" LBP"<<endl;
		cout<<"VAT Rate= "<<Vat<<" %"<<endl<<endl;
	}
	void printbill()
	{ 
		double month=(((MonthlySubscriptionFee+(nbrminutes*MinutesPrice))*Vat)/100);
		double total=(MonthlySubscriptionFee+(nbrminutes*MinutesPrice)+month);
		cout<<"*********Local Phone Bill**********"<<endl;
		cout<<"Monthly Fee= "<<MonthlySubscriptionFee<<"LL"<<endl;
		cout<<"Minutes Fee= "<<nbrminutes*MinutesPrice<<"$"<<endl;
		cout<<"10 % of VAT= "<<month<<endl;
		cout<<"Total of: "<<total<<endl<<endl;
	}

protected:
	unsigned int MonthlySubscriptionFee;
	unsigned int MinutesPrice;
	unsigned int CityTax;

	};
class MobileTelephoneAccount :public TelephoneAccounts
{
	friend ostream &operator<<(ostream &, MobileTelephoneAccount &);
public:
	
		MobileTelephoneAccount( double monsubfee=25, unsigned int nbrosms=0,  double minfee=0.22,
		 double smsfee=0.15,unsigned int nbrofmin=0,unsigned int vattax=10) :TelephoneAccounts(nbrofmin, vattax)
			{
				monthlysubfee=monsubfee;
				nbrsms=nbrosms;
				smsprice=smsfee;
				minutesprice=minfee;
			}
MobileTelephoneAccount &operator++()
{ 
	nbrsms+=1;
		return *this;
}

void printtax()
{
		cout<<"********Mobile Phone Account*********"<<endl;
		cout<<"VAT Rate= "<<Vat<<"%"<<endl<<endl;
}
void printbill()
{
		double month=(((monthlysubfee+(nbrsms*smsprice)+(nbrminutes*minutesprice))*Vat)/100);
		double total=(monthlysubfee+(nbrsms*smsprice)+(nbrminutes*minutesprice)+month);

		cout<<"*********Mobile Phone Bill**********"<<endl;
		cout<<"Monthly Fee= "<<monthlysubfee<<"LL"<<endl;
		cout<<"Minutes Fee= "<<nbrminutes*minutesprice<<"$"<<endl;
		cout<<"SMS Fee= "<<nbrsms*smsprice<<endl;
		cout<<"10 % of VAT= "<<month<<endl;
		cout<<"Total of: "<<total<<endl<<endl;
	}
protected:
	 double monthlysubfee;
	 double nbrsms;
	 double smsprice;
	 double minutesprice;
};
class InternationalTelephoneAccount :public TelephoneAccounts
{
	friend ostream &operator<<(ostream &, InternationalTelephoneAccount &);
public:
	InternationalTelephoneAccount(unsigned int callprice=2000, unsigned int nbrocall=0,
	unsigned int minprice=700,unsigned int nbrofmin=0,unsigned int vattax=10) :TelephoneAccounts(nbrofmin, vattax)
	{
			callfee=callprice;
			numberofcalls=nbrocall;
			minuteprice=minprice;
	}
void printtax()
{
		cout<<"********International Phone Account*********"<<endl;
		cout<<"VAT Rate= "<<Vat<<" %"<<endl<<endl;
}
void printbill()
	{ 
		double month=((((callfee*numberofcalls)+(nbrminutes*minuteprice))*Vat)/100);
		double total=((callfee*numberofcalls)+(nbrminutes*minuteprice)+month);
		cout<<"*********International Phone Bill**********"<<endl;
		cout<<"Call Fee= "<<callfee*numberofcalls<<" LL"<<endl;
		cout<<"Minutes Fee= "<<nbrminutes*minuteprice<<" $"<<endl;
		cout<<"10 % of VAT= "<<month<<endl;
		cout<<"Total of: "<<total<<endl<<endl;
	}

protected:
	unsigned int callfee;
	unsigned int numberofcalls;
	unsigned int minuteprice;
};
ostream &operator<<(ostream &output, TelephoneAccounts &account)
{
	output<<"Number of minutes= "<<account.nbrminutes<<endl;
	output<<"VAT Rate= "<<account.Vat<<endl<<endl;
	return output;
}
ostream &operator<<(ostream &out, LocalTelephoneAccounts &account)
{
	out<<"********Local Phone Account*********"<<endl;
	out<<"Monthly Subscription Fee= "<<account.MonthlySubscriptionFee<<" LBP"<<endl;
	out<<"Number of Minutes= "<<account.nbrminutes<<endl;
	out<<"Minutes Price: "<<account.MinutesPrice<<" LBP"<<endl;
	out<<"City Tax= "<<account.CityTax<<" LBP"<<endl;
	out<<"VAT Rate= "<<account.Vat<<" %"<<endl<<endl;
	return out;
}
ostream &operator<<(ostream &out, MobileTelephoneAccount &account)
{
	out<<"********Mobile Phone Account*********"<<endl;
	out<<"Monthly Subscription Fee= "<<account.monthlysubfee<<" $"<<endl;
	out<<"Number of Minutes= "<<account.nbrminutes<<endl;
	out<<"Minutes Price: "<<account.minutesprice<<" LBP"<<endl;
	out<<"Number of SMS= "<<account.nbrsms<<endl;
	out<<"SMS Price= "<<account.smsprice<<endl;
	out<<"VAT Rate= "<<account.Vat<<"%"<<endl<<endl;
	return out;
}
ostream &operator<<(ostream &out, InternationalTelephoneAccount &account)
{
	out<<"*********International Phone Account**********"<<endl;
	out<<"Number of Calls= "<<account.numberofcalls<<" LBP"<<endl;
	out<<"Call Fee= "<<account.callfee<<" LBP"<<endl;
	out<<"Number of Minutes= "<<account.nbrminutes<<endl;
	out<<"Minutes Price: "<<account.minuteprice<<" LBP"<<endl;
	out<<"VAT Rate= "<<account.Vat<<" %"<<endl<<endl;
	return out;
}

void main()
{
	
	LocalTelephoneAccounts phone(14000,1);
	MobileTelephoneAccount cellphone(50);
	InternationalTelephoneAccount telephone(4000,2);
	
	phone.printtax();
	phone.printbill();
	cellphone.printtax();
	cellphone.printbill();
	telephone.printtax();
	telephone.printbill();
	TelephoneAccounts *Maphone[3];
	Maphone[0]=new LocalTelephoneAccounts(3000,3,50);  // dynamic binding and testing polymorphic behavior
	Maphone[1]=new MobileTelephoneAccount;				// dynamic binding and testing polymorphic behavior
	Maphone[2]=new InternationalTelephoneAccount(5000,2,300,3,15);	// dynamic binding and testing polymorphic behavior
	Maphone[0]->printtax();
	Maphone[0]->printbill();
	Maphone[1]->printtax();
	Maphone[1]->printbill();
	Maphone[2]->printtax();
	Maphone[2]->printbill();

	cout<<phone<<cellphone<<telephone;

	
	phone+=10;		//increment the number of minutes for the class LocalTelephoneAccounts
	phone.printtax();
	TelephoneAccounts &cell=phone;
	phone.printbill();
	cout<<cellphone;
	cellphone++;		//testing the incrementing function

	cout<<cellphone;

}








	
	
	




		